<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.5.47">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">

<meta name="description" content="Introduction à l’analyse de réseau avec R">

<title>1&nbsp; L’objet igraph – Analyse de réseau avec `igraph`</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
/* CSS for syntax highlighting */
pre > code.sourceCode { white-space: pre; position: relative; }
pre > code.sourceCode > span { line-height: 1.25; }
pre > code.sourceCode > span:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode > span { color: inherit; text-decoration: inherit; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
pre > code.sourceCode { white-space: pre-wrap; }
pre > code.sourceCode > span { display: inline-block; text-indent: -5em; padding-left: 5em; }
}
pre.numberSource code
  { counter-reset: source-line 0; }
pre.numberSource code > span
  { position: relative; left: -4em; counter-increment: source-line; }
pre.numberSource code > span > a:first-child::before
  { content: counter(source-line);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
  }
pre.numberSource { margin-left: 3em;  padding-left: 4px; }
div.sourceCode
  {   }
@media screen {
pre > code.sourceCode > span > a:first-child::before { text-decoration: underline; }
}
</style>


<script src="site_libs/quarto-nav/quarto-nav.js"></script>
<script src="site_libs/quarto-nav/headroom.min.js"></script>
<script src="site_libs/clipboard/clipboard.min.js"></script>
<script src="site_libs/quarto-search/autocomplete.umd.js"></script>
<script src="site_libs/quarto-search/fuse.min.js"></script>
<script src="site_libs/quarto-search/quarto-search.js"></script>
<meta name="quarto:offset" content="./">
<link href="./indicateurs.html" rel="next">
<link href="./index.html" rel="prev">
<link href="./cover.png" rel="icon" type="image/png">
<script src="site_libs/quarto-html/quarto.js"></script>
<script src="site_libs/quarto-html/popper.min.js"></script>
<script src="site_libs/quarto-html/tippy.umd.min.js"></script>
<script src="site_libs/quarto-html/anchor.min.js"></script>
<link href="site_libs/quarto-html/tippy.css" rel="stylesheet">
<link href="site_libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="site_libs/bootstrap/bootstrap.min.js"></script>
<link href="site_libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="site_libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">
<script id="quarto-search-options" type="application/json">{
  "location": "sidebar",
  "copy-button": false,
  "collapse-after": 3,
  "panel-placement": "start",
  "type": "textbox",
  "limit": 50,
  "keyboard-shortcut": [
    "f",
    "/",
    "s"
  ],
  "show-item-context": false,
  "language": {
    "search-no-results-text": "Pas de résultats",
    "search-matching-documents-text": "documents trouvés",
    "search-copy-link-title": "Copier le lien vers la recherche",
    "search-hide-matches-text": "Cacher les correspondances additionnelles",
    "search-more-match-text": "correspondance de plus dans ce document",
    "search-more-matches-text": "correspondances de plus dans ce document",
    "search-clear-button-title": "Effacer",
    "search-text-placeholder": "",
    "search-detached-cancel-button-title": "Annuler",
    "search-submit-button-title": "Envoyer",
    "search-label": "Recherche"
  }
}</script>
<link href="site_libs/htmltools-fill-0.5.8.1/fill.css" rel="stylesheet">
<script src="site_libs/htmlwidgets-1.6.4/htmlwidgets.js"></script>
<link href="site_libs/datatables-css-0.0.0/datatables-crosstalk.css" rel="stylesheet">
<script src="site_libs/datatables-binding-0.33/datatables.js"></script>
<script src="site_libs/jquery-3.6.0/jquery-3.6.0.min.js"></script>
<link href="site_libs/dt-core-1.13.6/css/jquery.dataTables.min.css" rel="stylesheet">
<link href="site_libs/dt-core-1.13.6/css/jquery.dataTables.extra.css" rel="stylesheet">
<script src="site_libs/dt-core-1.13.6/js/jquery.dataTables.min.js"></script>
<link href="site_libs/crosstalk-1.2.1/css/crosstalk.min.css" rel="stylesheet">
<script src="site_libs/crosstalk-1.2.1/js/crosstalk.min.js"></script>

  <script src="https://cdnjs.cloudflare.com/polyfill/v3/polyfill.min.js?features=es6"></script>
  <script src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js" type="text/javascript"></script>

<script type="text/javascript">
const typesetMath = (el) => {
  if (window.MathJax) {
    // MathJax Typeset
    window.MathJax.typeset([el]);
  } else if (window.katex) {
    // KaTeX Render
    var mathElements = el.getElementsByClassName("math");
    var macros = [];
    for (var i = 0; i < mathElements.length; i++) {
      var texText = mathElements[i].firstChild;
      if (mathElements[i].tagName == "SPAN") {
        window.katex.render(texText.data, mathElements[i], {
          displayMode: mathElements[i].classList.contains('display'),
          throwOnError: false,
          macros: macros,
          fleqn: false
        });
      }
    }
  }
}
window.Quarto = {
  typesetMath
};
</script>

<meta property="og:title" content="1&nbsp; L’objet igraph – Analyse de réseau avec igraph">
<meta property="og:description" content="Introduction à l’analyse de réseau avec R">
<meta property="og:site_name" content="Analyse de réseau avec `igraph`">
</head>

<body class="nav-sidebar floating">

<div id="quarto-search-results"></div>
  <header id="quarto-header" class="headroom fixed-top">
  <nav class="quarto-secondary-nav">
    <div class="container-fluid d-flex">
      <button type="button" class="quarto-btn-toggle btn" data-bs-toggle="collapse" role="button" data-bs-target=".quarto-sidebar-collapse-item" aria-controls="quarto-sidebar" aria-expanded="false" aria-label="Basculer la barre latérale" onclick="if (window.quartoToggleHeadroom) { window.quartoToggleHeadroom(); }">
        <i class="bi bi-layout-text-sidebar-reverse"></i>
      </button>
        <nav class="quarto-page-breadcrumbs" aria-label="breadcrumb"><ol class="breadcrumb"><li class="breadcrumb-item"><a href="./igraph.html"><span class="chapter-number">1</span>&nbsp; <span class="chapter-title">L’objet <code>igraph</code></span></a></li></ol></nav>
        <a class="flex-grow-1" role="navigation" data-bs-toggle="collapse" data-bs-target=".quarto-sidebar-collapse-item" aria-controls="quarto-sidebar" aria-expanded="false" aria-label="Basculer la barre latérale" onclick="if (window.quartoToggleHeadroom) { window.quartoToggleHeadroom(); }">      
        </a>
      <button type="button" class="btn quarto-search-button" aria-label="Recherche" onclick="window.quartoOpenSearch();">
        <i class="bi bi-search"></i>
      </button>
    </div>
  </nav>
</header>
<!-- content -->
<div id="quarto-content" class="quarto-container page-columns page-rows-contents page-layout-article">
<!-- sidebar -->
  <nav id="quarto-sidebar" class="sidebar collapse collapse-horizontal quarto-sidebar-collapse-item sidebar-navigation floating overflow-auto">
    <div class="pt-lg-2 mt-2 text-left sidebar-header">
    <div class="sidebar-title mb-0 py-0">
      <a href="./">Analyse de réseau avec <code>igraph</code></a> 
    </div>
      </div>
        <div class="mt-2 flex-shrink-0 align-items-center">
        <div class="sidebar-search">
        <div id="quarto-search" class="" title="Recherche"></div>
        </div>
        </div>
    <div class="sidebar-menu-container"> 
    <ul class="list-unstyled mt-1">
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./index.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Le package <code>igraph</code></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./igraph.html" class="sidebar-item-text sidebar-link active">
 <span class="menu-text"><span class="chapter-number">1</span>&nbsp; <span class="chapter-title">L’objet <code>igraph</code></span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./indicateurs.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">2</span>&nbsp; <span class="chapter-title">Indicateurs globaux</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./mesures.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">3</span>&nbsp; <span class="chapter-title">Mesures locales</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./communaute.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">4</span>&nbsp; <span class="chapter-title">Cliques et communautés</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./graphique.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text"><span class="chapter-number">5</span>&nbsp; <span class="chapter-title">Représentation graphique</span></span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./conclusion.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Conclusion</span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./exercice.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Exercice</span></a>
  </div>
</li>
        <li class="sidebar-item">
  <div class="sidebar-item-container"> 
  <a href="./references.html" class="sidebar-item-text sidebar-link">
 <span class="menu-text">Références</span></a>
  </div>
</li>
    </ul>
    </div>
</nav>
<div id="quarto-sidebar-glass" class="quarto-sidebar-collapse-item" data-bs-toggle="collapse" data-bs-target=".quarto-sidebar-collapse-item"></div>
<!-- margin-sidebar -->
    <div id="quarto-margin-sidebar" class="sidebar margin-sidebar">
        <nav id="TOC" role="doc-toc" class="toc-active">
    <h2 id="toc-title">Table des matières</h2>
   
  <ul>
  <li><a href="#le-jeu-de-données-karate" id="toc-le-jeu-de-données-karate" class="nav-link active" data-scroll-target="#le-jeu-de-données-karate"><span class="header-section-number">1.1</span> Le jeu de données karate</a>
  <ul class="collapse">
  <li><a href="#propriétés-des-arêtes-edges" id="toc-propriétés-des-arêtes-edges" class="nav-link" data-scroll-target="#propriétés-des-arêtes-edges"><span class="header-section-number">1.1.1</span> Propriétés des arêtes (<em>edges</em>)</a></li>
  <li><a href="#propriétés-des-sommets-vertices" id="toc-propriétés-des-sommets-vertices" class="nav-link" data-scroll-target="#propriétés-des-sommets-vertices"><span class="header-section-number">1.1.2</span> Propriétés des sommets (<em>vertices</em>)</a></li>
  </ul></li>
  <li><a href="#construction-dun-graphe" id="toc-construction-dun-graphe" class="nav-link" data-scroll-target="#construction-dun-graphe"><span class="header-section-number">1.2</span> Construction d’un graphe</a></li>
  <li><a href="#interrogation-dun-graphe" id="toc-interrogation-dun-graphe" class="nav-link" data-scroll-target="#interrogation-dun-graphe"><span class="header-section-number">1.3</span> Interrogation d’un graphe</a></li>
  <li><a href="#réseau-valué" id="toc-réseau-valué" class="nav-link" data-scroll-target="#réseau-valué"><span class="header-section-number">1.4</span> Réseau valué</a></li>
  <li><a href="#modification-dun-graphe" id="toc-modification-dun-graphe" class="nav-link" data-scroll-target="#modification-dun-graphe"><span class="header-section-number">1.5</span> Modification d’un graphe</a></li>
  <li><a href="#extraction-dun-sous-graphe" id="toc-extraction-dun-sous-graphe" class="nav-link" data-scroll-target="#extraction-dun-sous-graphe"><span class="header-section-number">1.6</span> Extraction d’un sous-graphe</a></li>
  <li><a href="#extraction-des-ego-networks" id="toc-extraction-des-ego-networks" class="nav-link" data-scroll-target="#extraction-des-ego-networks"><span class="header-section-number">1.7</span> Extraction des ego-networks</a></li>
  <li><a href="#boucles-et-liens-multiples" id="toc-boucles-et-liens-multiples" class="nav-link" data-scroll-target="#boucles-et-liens-multiples"><span class="header-section-number">1.8</span> Boucles et liens multiples</a></li>
  <li><a href="#réseau-bimodal-ou-biparti" id="toc-réseau-bimodal-ou-biparti" class="nav-link" data-scroll-target="#réseau-bimodal-ou-biparti"><span class="header-section-number">1.9</span> Réseau bimodal (ou biparti)</a></li>
  <li><a href="#exporter-un-objet-igraph" id="toc-exporter-un-objet-igraph" class="nav-link" data-scroll-target="#exporter-un-objet-igraph"><span class="header-section-number">1.10</span> Exporter un objet <code>igraph</code></a></li>
  </ul>
</nav>
    </div>
<!-- main -->
<main class="content" id="quarto-document-content">

<header id="title-block-header" class="quarto-title-block default">
<div class="quarto-title">
<h1 class="title"><span class="chapter-number">1</span>&nbsp; <span class="chapter-title">L’objet <code>igraph</code></span></h1>
</div>



<div class="quarto-title-meta">

    
  
    
  </div>
  


</header>


<p>Le <em>package</em> est structuré autour de l’objet <code>igraph</code> qui permet de représenter un graphe composé de sommets (nœuds) reliés par des arêtes (liens).</p>
<p>L’objet <code>igraph</code> est de type <code>list</code>. Tous les éléments qui décrivent un graphe sont ainsi stockés dans un seul et unique objet que l’on va pouvoir manipuler, interroger, analyser et visualiser.</p>
<p>Dans cet objet :</p>
<ul>
<li><p><strong>les sommets</strong> sont stockés dans l’élément <strong><em>vertices</em></strong> qui contient leurs noms ;</p></li>
<li><p><strong>les arêtes</strong> sont stockées dans l’élément <strong><em>edges</em></strong> qui contient le sommet de départ et d’arrivée de chaque arête ;</p></li>
<li><p>les <strong>attributs</strong> des sommets et des arêtes sont contenus dans les <strong><em>vertex.attributes</em></strong> et <strong><em>edge.attributes</em></strong>.</p></li>
</ul>
<p>Le réseau peut être orienté ou non orienté (<em>un-directed</em>), booléen ou valué (<em>binary</em> ou <em>weighted</em>), unimodal ou biparti (<em>bipartite</em>), simple ou avec boucles et/ou liens multiples.</p>
<p>Les différentes fonctions du <em>package</em> permettent de manipuler l’objet <code>igraph</code> à sa guise. Il s’agit d’une librairie relativement complète que ce support ne fait que survoler.</p>
<section id="le-jeu-de-données-karate" class="level2" data-number="1.1">
<h2 data-number="1.1" class="anchored" data-anchor-id="le-jeu-de-données-karate"><span class="header-section-number">1.1</span> Le jeu de données karate</h2>
<p>Les données utilisées sont fournies par le package <code>igraphdata</code>. Il s’agit du jeu de données <strong><em>karate</em></strong> qui contient le réseau social entre les membres d’un club de karaté universitaire dirigé par le président John A. et l’instructeur de karaté M. Hi (pseudonymes).</p>
<div class="cell">
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-2-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
<p>Ces données ont été collectées par l’anthropologue américain Wayne Zachary, d’où le nom de <em>Zachary karate club</em> souvent utilisé pour nommer ce jeu de données. Il a observé les relations entre praticiens d’un club de karaté pendant plus de deux ans dans huit contextes sociaux différents. Les matrices de relations ont ensuite été agrégées, ce qui donne un réseau non orienté et valué ; l’intensité des liens correspond au nombre de contextes différents dans lesquels deux praticiens sont en relation. Ce jeu est souvent utilisé pour tester des méthodes de détection de communautés pour une raison simple : lors de son observation, une scission s’est produite et un club dissident a été créé, drainant une partie des élèves.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb1"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb1-1"><a href="#cb1-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Chargement de la librairie igraphdata</span></span>
<span id="cb1-2"><a href="#cb1-2" aria-hidden="true" tabindex="-1"></a><span class="fu">library</span>(igraphdata)</span>
<span id="cb1-3"><a href="#cb1-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-4"><a href="#cb1-4" aria-hidden="true" tabindex="-1"></a><span class="co"># Chargement du jeu de données exemple</span></span>
<span id="cb1-5"><a href="#cb1-5" aria-hidden="true" tabindex="-1"></a><span class="fu">data</span>(karate)</span>
<span id="cb1-6"><a href="#cb1-6" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb1-7"><a href="#cb1-7" aria-hidden="true" tabindex="-1"></a><span class="co"># Description du jeu de données</span></span>
<span id="cb1-8"><a href="#cb1-8" aria-hidden="true" tabindex="-1"></a>?karate</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<section id="propriétés-des-arêtes-edges" class="level3" data-number="1.1.1">
<h3 data-number="1.1.1" class="anchored" data-anchor-id="propriétés-des-arêtes-edges"><span class="header-section-number">1.1.1</span> Propriétés des arêtes (<em>edges</em>)</h3>
<div class="cell">
<div class="cell-output-display">
<div class="datatables html-widget html-fill-item" id="htmlwidget-285fb22d9fc6f734d566" style="width:100%;height:auto;"></div>
<script type="application/json" data-for="htmlwidget-285fb22d9fc6f734d566">{"x":{"filter":"none","vertical":false,"data":[["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78"],["Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Mr Hi","Actor 2","Actor 2","Actor 2","Actor 2","Actor 2","Actor 2","Actor 2","Actor 2","Actor 3","Actor 3","Actor 3","Actor 3","Actor 3","Actor 3","Actor 3","Actor 3","Actor 4","Actor 4","Actor 4","Actor 5","Actor 5","Actor 6","Actor 6","Actor 6","Actor 7","Actor 9","Actor 9","Actor 9","Actor 10","Actor 14","Actor 15","Actor 15","Actor 16","Actor 16","Actor 19","Actor 19","Actor 20","Actor 21","Actor 21","Actor 23","Actor 23","Actor 24","Actor 24","Actor 24","Actor 24","Actor 24","Actor 25","Actor 25","Actor 25","Actor 26","Actor 27","Actor 27","Actor 28","Actor 29","Actor 29","Actor 30","Actor 30","Actor 31","Actor 31","Actor 32","Actor 32","Actor 33"],["Actor 2","Actor 3","Actor 4","Actor 5","Actor 6","Actor 7","Actor 8","Actor 9","Actor 11","Actor 12","Actor 13","Actor 14","Actor 18","Actor 20","Actor 22","Actor 32","Actor 3","Actor 4","Actor 8","Actor 14","Actor 18","Actor 20","Actor 22","Actor 31","Actor 4","Actor 8","Actor 9","Actor 10","Actor 14","Actor 28","Actor 29","Actor 33","Actor 8","Actor 13","Actor 14","Actor 7","Actor 11","Actor 7","Actor 11","Actor 17","Actor 17","Actor 31","Actor 33","John A","John A","John A","Actor 33","John A","Actor 33","John A","Actor 33","John A","John A","Actor 33","John A","Actor 33","John A","Actor 26","Actor 28","Actor 30","Actor 33","John A","Actor 26","Actor 28","Actor 32","Actor 32","Actor 30","John A","John A","Actor 32","John A","Actor 33","John A","Actor 33","John A","Actor 33","John A","John A"],[4,5,3,3,3,3,2,2,2,3,1,3,2,2,2,2,6,3,4,5,1,2,2,2,3,4,5,1,3,2,2,2,3,3,3,2,3,5,3,3,3,3,3,4,2,3,3,2,3,4,1,2,1,3,1,2,3,5,4,3,5,4,2,3,2,7,4,2,4,2,2,4,2,3,3,4,4,5]],"container":"<table class=\"cell-border stripe\">\n  <thead>\n    <tr>\n      <th> <\/th>\n      <th>from<\/th>\n      <th>to<\/th>\n      <th>weight<\/th>\n    <\/tr>\n  <\/thead>\n<\/table>","options":{"pageLength":10,"columnDefs":[{"className":"dt-right","targets":3},{"orderable":false,"targets":0},{"name":" ","targets":0},{"name":"from","targets":1},{"name":"to","targets":2},{"name":"weight","targets":3}],"order":[],"autoWidth":false,"orderClasses":false}},"evals":[],"jsHooks":[]}</script>
</div>
</div>
</section>
<section id="propriétés-des-sommets-vertices" class="level3" data-number="1.1.2">
<h3 data-number="1.1.2" class="anchored" data-anchor-id="propriétés-des-sommets-vertices"><span class="header-section-number">1.1.2</span> Propriétés des sommets (<em>vertices</em>)</h3>
<div class="cell">
<div class="cell-output-display">
<div class="datatables html-widget html-fill-item" id="htmlwidget-f2ace892e9af96dad1c8" style="width:100%;height:auto;"></div>
<script type="application/json" data-for="htmlwidget-f2ace892e9af96dad1c8">{"x":{"filter":"none","vertical":false,"data":[["Mr Hi","Actor 2","Actor 3","Actor 4","Actor 5","Actor 6","Actor 7","Actor 8","Actor 9","Actor 10","Actor 11","Actor 12","Actor 13","Actor 14","Actor 15","Actor 16","Actor 17","Actor 18","Actor 19","Actor 20","Actor 21","Actor 22","Actor 23","Actor 24","Actor 25","Actor 26","Actor 27","Actor 28","Actor 29","Actor 30","Actor 31","Actor 32","Actor 33","John A"],["Mr Hi","Actor 2","Actor 3","Actor 4","Actor 5","Actor 6","Actor 7","Actor 8","Actor 9","Actor 10","Actor 11","Actor 12","Actor 13","Actor 14","Actor 15","Actor 16","Actor 17","Actor 18","Actor 19","Actor 20","Actor 21","Actor 22","Actor 23","Actor 24","Actor 25","Actor 26","Actor 27","Actor 28","Actor 29","Actor 30","Actor 31","Actor 32","Actor 33","John A"],["H","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","A"],[1,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2],[1,1,1,1,1,1,1,1,2,2,1,1,1,1,2,2,1,1,2,1,2,1,2,2,2,2,2,2,2,2,2,2,2,2]],"container":"<table class=\"cell-border stripe\">\n  <thead>\n    <tr>\n      <th> <\/th>\n      <th>name<\/th>\n      <th>label<\/th>\n      <th>Faction<\/th>\n      <th>color<\/th>\n    <\/tr>\n  <\/thead>\n<\/table>","options":{"pageLength":10,"columnDefs":[{"className":"dt-right","targets":[3,4]},{"orderable":false,"targets":0},{"name":" ","targets":0},{"name":"name","targets":1},{"name":"label","targets":2},{"name":"Faction","targets":3},{"name":"color","targets":4}],"order":[],"autoWidth":false,"orderClasses":false}},"evals":[],"jsHooks":[]}</script>
</div>
</div>
</section>
</section>
<section id="construction-dun-graphe" class="level2" data-number="1.2">
<h2 data-number="1.2" class="anchored" data-anchor-id="construction-dun-graphe"><span class="header-section-number">1.2</span> Construction d’un graphe</h2>
<p>Il est possible de construire un objet <code>igraph</code> à partir de différents types de données :</p>
<ul>
<li>une liste de liens (arêtes) : <code>graph_from_edgelist()</code> ;</li>
<li>une matrice d’adjacence (arêtes) : <code>graph_from_adjacency_matrix()</code>;</li>
<li>un ou deux tableaux (arêtes, arêtes et sommets) : <strong><code>graph_from_data_frame()</code></strong>.</li>
</ul>
<div class="callout callout-style-simple callout-note no-icon">
<div class="callout-body d-flex">
<div class="callout-icon-container">
<i class="callout-icon no-icon"></i>
</div>
<div class="callout-body-container">
<p>Le package <code>igraph</code> permet également d’importer (et d’exporter) des graphes de différents formats : Pajek, GraphViz, LEDA, GML, GraphML, DIMACS, LGL…</p>
</div>
</div>
</div>
<p>Construire un graphe à partir d’un <code>data.frame</code> de liens (arêtes) et d’un <code>data.frame</code> contenant les sommets.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb2"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb2-1"><a href="#cb2-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Création de l'objet `igraph`</span></span>
<span id="cb2-2"><a href="#cb2-2" aria-hidden="true" tabindex="-1"></a>karate <span class="ot">&lt;-</span> <span class="fu">graph_from_data_frame</span>(<span class="at">d =</span> tableau_aretes,</span>
<span id="cb2-3"><a href="#cb2-3" aria-hidden="true" tabindex="-1"></a>                                <span class="at">vertices =</span> tableau_sommets, </span>
<span id="cb2-4"><a href="#cb2-4" aria-hidden="true" tabindex="-1"></a>                                <span class="at">directed =</span> <span class="cn">FALSE</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>Ajouter des attributs à l’ensemble du graphe.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb3"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb3-1"><a href="#cb3-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Un nom</span></span>
<span id="cb3-2"><a href="#cb3-2" aria-hidden="true" tabindex="-1"></a><span class="fu">graph_attr</span>(karate, <span class="st">"name"</span>) <span class="ot">&lt;-</span> <span class="st">"Zachary's karate club network"</span></span>
<span id="cb3-3"><a href="#cb3-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb3-4"><a href="#cb3-4" aria-hidden="true" tabindex="-1"></a><span class="co"># Des auteurs</span></span>
<span id="cb3-5"><a href="#cb3-5" aria-hidden="true" tabindex="-1"></a><span class="fu">graph_attr</span>(karate, <span class="st">"Author"</span>) <span class="ot">&lt;-</span> <span class="st">"Wayne W. Zachary"</span></span>
<span id="cb3-6"><a href="#cb3-6" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb3-7"><a href="#cb3-7" aria-hidden="true" tabindex="-1"></a><span class="co"># Une citation</span></span>
<span id="cb3-8"><a href="#cb3-8" aria-hidden="true" tabindex="-1"></a><span class="fu">graph_attr</span>(karate, <span class="st">"Citation"</span>) <span class="ot">&lt;-</span> <span class="st">"Wayne W. Zachary. An Information Flow Model for Conflict and Fission in Small Groups. Journal of Anthropological Research Vol. 33, No. 4 452-473"</span></span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
</section>
<section id="interrogation-dun-graphe" class="level2" data-number="1.3">
<h2 data-number="1.3" class="anchored" data-anchor-id="interrogation-dun-graphe"><span class="header-section-number">1.3</span> Interrogation d’un graphe</h2>
<div class="cell">
<div class="sourceCode cell-code" id="cb4"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb4-1"><a href="#cb4-1" aria-hidden="true" tabindex="-1"></a><span class="fu">class</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] "igraph"</code></pre>
</div>
<div class="sourceCode cell-code" id="cb6"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb6-1"><a href="#cb6-1" aria-hidden="true" tabindex="-1"></a><span class="fu">summary</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH 20bd41a UNW- 34 78 -- Zachary's karate club network
+ attr: name (g/c), Author (g/c), Citation (g/c), name (v/c), label
| (v/c), Faction (v/n), color (v/n), weight (e/n)</code></pre>
</div>
</div>
<p>Description de l’objet <code>igraph</code> en trois ou quatre lettres :</p>
<p><strong>D ou U</strong> : <strong>graphe orienté</strong>, <em>Directed</em> ou <em>Undirected</em><br>
<strong>N</strong> : <strong><em>Named graph</em></strong>, les sommets possèdent un attribut <em>name</em><br>
<strong>W</strong> : <strong>pondéré</strong>, les liens possèdent un attribut <em>weight</em>.</p>
<p>Lorsqu’un <strong>B</strong> est présent, cela signale un graphe considéré comme bimodal (<strong>bipartite</strong>): les sommets possèdent un attribut <em>type</em> (booléen) qui différencie les deux ensembles de sommets.</p>
<p>Les chiffres qui suivent (34 et 78) indiquent le nombre de sommets (ordre) et le nombre d’arêtes (taille).</p>
<p>Chaque attribut est également listé. La première lettre indique à quel élément se rattache l’attribut et la seconde indique le type de variable. Exemple :</p>
<p>(g/c) = Graph/Character<br>
(v/c) = Vertex / Character<br>
(e/n) = Edge / Numeric</p>
<p>La fonction <code>str()</code> permet d’avoir une vision plus détaillée du graphe.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb8"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb8-1"><a href="#cb8-1" aria-hidden="true" tabindex="-1"></a><span class="fu">str</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>Class 'igraph'  hidden list of 10
 $ : num 34
 $ : logi FALSE
 $ : num [1:78] 1 2 3 4 5 6 7 8 10 11 ...
 $ : num [1:78] 0 0 0 0 0 0 0 0 0 0 ...
 $ : NULL
 $ : NULL
 $ : NULL
 $ : NULL
 $ :List of 4
  ..$ : num [1:3] 1 0 1
  ..$ :List of 3
  .. ..$ name    : chr "Zachary's karate club network"
  .. ..$ Author  : chr "Wayne W. Zachary"
  .. ..$ Citation: chr "Wayne W. Zachary. An Information Flow Model for Conflict and Fission in Small Groups. Journal of Anthropologica"| __truncated__
  ..$ :List of 4
  .. ..$ name   : chr [1:34] "Mr Hi" "Actor 2" "Actor 3" "Actor 4" ...
  .. ..$ label  : chr [1:34] "H" "2" "3" "4" ...
  .. ..$ Faction: num [1:34] 1 1 1 1 1 1 1 1 2 2 ...
  .. ..$ color  : num [1:34] 1 1 1 1 1 1 1 1 2 2 ...
  ..$ :List of 1
  .. ..$ weight: num [1:78] 4 5 3 3 3 3 2 2 2 3 ...
 $ :&lt;environment: 0x589a2d6c70f8&gt; </code></pre>
</div>
</div>
<p>Les fonctions <code>V()</code> et <code>E()</code> permettent de lister les sommets et les arêtes du graphe.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb10"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb10-1"><a href="#cb10-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Vertices - Sommets</span></span>
<span id="cb10-2"><a href="#cb10-2" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>+ 34/34 vertices, named, from 20bd41a:
 [1] Mr Hi    Actor 2  Actor 3  Actor 4  Actor 5  Actor 6  Actor 7  Actor 8 
 [9] Actor 9  Actor 10 Actor 11 Actor 12 Actor 13 Actor 14 Actor 15 Actor 16
[17] Actor 17 Actor 18 Actor 19 Actor 20 Actor 21 Actor 22 Actor 23 Actor 24
[25] Actor 25 Actor 26 Actor 27 Actor 28 Actor 29 Actor 30 Actor 31 Actor 32
[33] Actor 33 John A  </code></pre>
</div>
<div class="sourceCode cell-code" id="cb12"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb12-1"><a href="#cb12-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Edge - Arêtes</span></span>
<span id="cb12-2"><a href="#cb12-2" aria-hidden="true" tabindex="-1"></a><span class="fu">E</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>+ 78/78 edges from 20bd41a (vertex names):
 [1] Mr Hi  --Actor 2  Mr Hi  --Actor 3  Mr Hi  --Actor 4  Mr Hi  --Actor 5 
 [5] Mr Hi  --Actor 6  Mr Hi  --Actor 7  Mr Hi  --Actor 8  Mr Hi  --Actor 9 
 [9] Mr Hi  --Actor 11 Mr Hi  --Actor 12 Mr Hi  --Actor 13 Mr Hi  --Actor 14
[13] Mr Hi  --Actor 18 Mr Hi  --Actor 20 Mr Hi  --Actor 22 Mr Hi  --Actor 32
[17] Actor 2--Actor 3  Actor 2--Actor 4  Actor 2--Actor 8  Actor 2--Actor 14
[21] Actor 2--Actor 18 Actor 2--Actor 20 Actor 2--Actor 22 Actor 2--Actor 31
[25] Actor 3--Actor 4  Actor 3--Actor 8  Actor 3--Actor 9  Actor 3--Actor 10
[29] Actor 3--Actor 14 Actor 3--Actor 28 Actor 3--Actor 29 Actor 3--Actor 33
[33] Actor 4--Actor 8  Actor 4--Actor 13 Actor 4--Actor 14 Actor 5--Actor 7 
[37] Actor 5--Actor 11 Actor 6--Actor 7  Actor 6--Actor 11 Actor 6--Actor 17
+ ... omitted several edges</code></pre>
</div>
</div>
<p>Comme avec un <code>data.frame</code>, on utilise un <code>$</code> pour sélectionner un attribut.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb14"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb14-1"><a href="#cb14-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Valeurs de l'attribut "Faction" des sommets</span></span>
<span id="cb14-2"><a href="#cb14-2" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)<span class="sc">$</span>Faction</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code> [1] 1 1 1 1 1 1 1 1 2 2 1 1 1 1 2 2 1 1 2 1 2 1 2 2 2 2 2 2 2 2 2 2 2 2</code></pre>
</div>
<div class="sourceCode cell-code" id="cb16"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb16-1"><a href="#cb16-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Valeurs de l'attribut "weight" des arêtes</span></span>
<span id="cb16-2"><a href="#cb16-2" aria-hidden="true" tabindex="-1"></a><span class="fu">E</span>(karate)<span class="sc">$</span>weight</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code> [1] 4 5 3 3 3 3 2 2 2 3 1 3 2 2 2 2 6 3 4 5 1 2 2 2 3 4 5 1 3 2 2 2 3 3 3 2 3 5
[39] 3 3 3 3 3 4 2 3 3 2 3 4 1 2 1 3 1 2 3 5 4 3 5 4 2 3 2 7 4 2 4 2 2 4 2 3 3 4
[77] 4 5</code></pre>
</div>
</div>
<p>Lister l’ensemble des attributs des sommets et des arêtes.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb18"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb18-1"><a href="#cb18-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Attributs des sommets</span></span>
<span id="cb18-2"><a href="#cb18-2" aria-hidden="true" tabindex="-1"></a><span class="fu">vertex_attr</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>$name
 [1] "Mr Hi"    "Actor 2"  "Actor 3"  "Actor 4"  "Actor 5"  "Actor 6" 
 [7] "Actor 7"  "Actor 8"  "Actor 9"  "Actor 10" "Actor 11" "Actor 12"
[13] "Actor 13" "Actor 14" "Actor 15" "Actor 16" "Actor 17" "Actor 18"
[19] "Actor 19" "Actor 20" "Actor 21" "Actor 22" "Actor 23" "Actor 24"
[25] "Actor 25" "Actor 26" "Actor 27" "Actor 28" "Actor 29" "Actor 30"
[31] "Actor 31" "Actor 32" "Actor 33" "John A"  

$label
 [1] "H"  "2"  "3"  "4"  "5"  "6"  "7"  "8"  "9"  "10" "11" "12" "13" "14" "15"
[16] "16" "17" "18" "19" "20" "21" "22" "23" "24" "25" "26" "27" "28" "29" "30"
[31] "31" "32" "33" "A" 

$Faction
 [1] 1 1 1 1 1 1 1 1 2 2 1 1 1 1 2 2 1 1 2 1 2 1 2 2 2 2 2 2 2 2 2 2 2 2

$color
 [1] 1 1 1 1 1 1 1 1 2 2 1 1 1 1 2 2 1 1 2 1 2 1 2 2 2 2 2 2 2 2 2 2 2 2</code></pre>
</div>
<div class="sourceCode cell-code" id="cb20"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb20-1"><a href="#cb20-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Attributs des arêtes</span></span>
<span id="cb20-2"><a href="#cb20-2" aria-hidden="true" tabindex="-1"></a><span class="fu">edge_attr</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>$weight
 [1] 4 5 3 3 3 3 2 2 2 3 1 3 2 2 2 2 6 3 4 5 1 2 2 2 3 4 5 1 3 2 2 2 3 3 3 2 3 5
[39] 3 3 3 3 3 4 2 3 3 2 3 4 1 2 1 3 1 2 3 5 4 3 5 4 2 3 2 7 4 2 4 2 2 4 2 3 3 4
[77] 4 5</code></pre>
</div>
</div>
</section>
<section id="réseau-valué" class="level2" data-number="1.4">
<h2 data-number="1.4" class="anchored" data-anchor-id="réseau-valué"><span class="header-section-number">1.4</span> Réseau valué</h2>
<p>Pour que le graphe soit considéré comme valué, la table de liens <strong>doit</strong> contenir un attribut (<em>numeric</em>) nommé <code>weight</code>. C’est le cas dans le jeu de données <em>karate</em>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb22"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb22-1"><a href="#cb22-1" aria-hidden="true" tabindex="-1"></a><span class="fu">E</span>(karate)<span class="sc">$</span>weight</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code> [1] 4 5 3 3 3 3 2 2 2 3 1 3 2 2 2 2 6 3 4 5 1 2 2 2 3 4 5 1 3 2 2 2 3 3 3 2 3 5
[39] 3 3 3 3 3 4 2 3 3 2 3 4 1 2 1 3 1 2 3 5 4 3 5 4 2 3 2 7 4 2 4 2 2 4 2 3 3 4
[77] 4 5</code></pre>
</div>
<div class="sourceCode cell-code" id="cb24"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb24-1"><a href="#cb24-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Fonction pour savoir si le graphe est valué</span></span>
<span id="cb24-2"><a href="#cb24-2" aria-hidden="true" tabindex="-1"></a><span class="fu">is_weighted</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] TRUE</code></pre>
</div>
</div>
</section>
<section id="modification-dun-graphe" class="level2" data-number="1.5">
<h2 data-number="1.5" class="anchored" data-anchor-id="modification-dun-graphe"><span class="header-section-number">1.5</span> Modification d’un graphe</h2>
<p>Ajouter des sommets.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb26"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb26-1"><a href="#cb26-1" aria-hidden="true" tabindex="-1"></a>karate <span class="ot">&lt;-</span> <span class="fu">add_vertices</span>(<span class="at">graph =</span> karate, </span>
<span id="cb26-2"><a href="#cb26-2" aria-hidden="true" tabindex="-1"></a>                       <span class="at">nv =</span> <span class="dv">1</span>, </span>
<span id="cb26-3"><a href="#cb26-3" aria-hidden="true" tabindex="-1"></a>                       <span class="at">name =</span> <span class="st">"Toto"</span>,</span>
<span id="cb26-4"><a href="#cb26-4" aria-hidden="true" tabindex="-1"></a>                       <span class="at">label =</span> <span class="st">"35"</span>,</span>
<span id="cb26-5"><a href="#cb26-5" aria-hidden="true" tabindex="-1"></a>                       <span class="at">Faction =</span> <span class="dv">1</span>,</span>
<span id="cb26-6"><a href="#cb26-6" aria-hidden="true" tabindex="-1"></a>                       <span class="at">color =</span> <span class="dv">1</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>Ajouter des arêtes.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb27"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb27-1"><a href="#cb27-1" aria-hidden="true" tabindex="-1"></a>karate <span class="ot">&lt;-</span> <span class="fu">add_edges</span>(<span class="at">graph =</span> karate, </span>
<span id="cb27-2"><a href="#cb27-2" aria-hidden="true" tabindex="-1"></a>                    <span class="at">edges =</span> <span class="fu">c</span>(<span class="st">"Mr Hi"</span>, <span class="st">"Toto"</span>, <span class="st">"Toto"</span>, <span class="st">"Actor 2"</span>),</span>
<span id="cb27-3"><a href="#cb27-3" aria-hidden="true" tabindex="-1"></a>                    <span class="at">attr =</span> <span class="fu">list</span>(<span class="at">weight =</span> <span class="dv">5</span>))</span>
<span id="cb27-4"><a href="#cb27-4" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb27-5"><a href="#cb27-5" aria-hidden="true" tabindex="-1"></a><span class="fu">summary</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH 7d3b4ac UNW- 35 80 -- Zachary's karate club network
+ attr: name (g/c), Author (g/c), Citation (g/c), name (v/c), label
| (v/c), Faction (v/n), color (v/n), weight (e/n)</code></pre>
</div>
</div>
<p>Modifier ou supprimer les attributs des sommets ou des arêtes.</p>
<p>Les arguments à renseigner pour les modifications sont <code>graph</code> (nom du graphe), <code>name</code> (nom de l’attribut à modifier), <code>index</code> (sous-ensemble d’arêtes que l’on veut modifier, optionnel), <code>value</code> (nouvelle valeur de l’attribut pour toutes les arêtes ou pour les arêtes du sous-ensemble défini dans <code>index</code>).</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb29"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb29-1"><a href="#cb29-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Suppression</span></span>
<span id="cb29-2"><a href="#cb29-2" aria-hidden="true" tabindex="-1"></a><span class="fu">delete_edge_attr</span>() </span>
<span id="cb29-3"><a href="#cb29-3" aria-hidden="true" tabindex="-1"></a><span class="fu">delete_vertex_attr</span>() </span>
<span id="cb29-4"><a href="#cb29-4" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb29-5"><a href="#cb29-5" aria-hidden="true" tabindex="-1"></a><span class="co"># Modification</span></span>
<span id="cb29-6"><a href="#cb29-6" aria-hidden="true" tabindex="-1"></a><span class="fu">set_edge_attr</span>() </span>
<span id="cb29-7"><a href="#cb29-7" aria-hidden="true" tabindex="-1"></a><span class="fu">set_vertex_attr</span>()</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p>Créer un attribut.</p>
<p>Les valeurs doivent respecter l’ordre des sommets de l’objet <code>igraph</code>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb30"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb30-1"><a href="#cb30-1" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)<span class="sc">$</span>position <span class="ot">&lt;-</span>  <span class="fu">c</span>(<span class="st">"Maître"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, </span>
<span id="cb30-2"><a href="#cb30-2" aria-hidden="true" tabindex="-1"></a>                         <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>,  <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, </span>
<span id="cb30-3"><a href="#cb30-3" aria-hidden="true" tabindex="-1"></a>                         <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, </span>
<span id="cb30-4"><a href="#cb30-4" aria-hidden="true" tabindex="-1"></a>                         <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Elève"</span>, <span class="st">"Maître"</span>, <span class="st">"Elève"</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
</section>
<section id="extraction-dun-sous-graphe" class="level2" data-number="1.6">
<h2 data-number="1.6" class="anchored" data-anchor-id="extraction-dun-sous-graphe"><span class="header-section-number">1.6</span> Extraction d’un sous-graphe</h2>
<p>Extraire des sous-graphes à partir d’un attribut des sommets.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb31"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb31-1"><a href="#cb31-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Sélection des membres de la faction 1</span></span>
<span id="cb31-2"><a href="#cb31-2" aria-hidden="true" tabindex="-1"></a>karate_faction_1 <span class="ot">&lt;-</span> <span class="fu">induced_subgraph</span>(karate, <span class="at">v =</span> <span class="fu">which</span>(<span class="fu">V</span>(karate)<span class="sc">$</span>Faction <span class="sc">==</span> <span class="dv">1</span>))</span>
<span id="cb31-3"><a href="#cb31-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb31-4"><a href="#cb31-4" aria-hidden="true" tabindex="-1"></a><span class="co"># Sélection des membres de la faction 2</span></span>
<span id="cb31-5"><a href="#cb31-5" aria-hidden="true" tabindex="-1"></a>karate_faction_2 <span class="ot">&lt;-</span> <span class="fu">induced_subgraph</span>(karate, <span class="at">v =</span> <span class="fu">which</span>(<span class="fu">V</span>(karate)<span class="sc">$</span>Faction <span class="sc">==</span> <span class="dv">2</span>))</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<div class="cell">
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-19-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
<p>Extraire un sous-graphe en fonction d’un attribut des liens.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb32"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb32-1"><a href="#cb32-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Sélection des liens d'intensité supérieure ou égale à 4</span></span>
<span id="cb32-2"><a href="#cb32-2" aria-hidden="true" tabindex="-1"></a>lien_intens_sup_4 <span class="ot">&lt;-</span> <span class="fu">subgraph.edges</span>(karate, <span class="at">eids =</span> <span class="fu">which</span>(<span class="fu">E</span>(karate)<span class="sc">$</span>weight <span class="sc">&gt;</span> <span class="dv">4</span>))</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<div class="cell">
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-21-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
</section>
<section id="extraction-des-ego-networks" class="level2" data-number="1.7">
<h2 data-number="1.7" class="anchored" data-anchor-id="extraction-des-ego-networks"><span class="header-section-number">1.7</span> Extraction des ego-networks</h2>
<p>La fonction <code>make_ego_graph</code> permet d’extraire les ego-networks d’un graphe. L’argument <code>order</code> permet de choisir le niveau de voisinage à prendre en compte (1 par défaut). L’argument <code>mode</code> permet de prendre en compte tous les liens (“all”), uniquement les liens entrants (“in”) ou uniquement les liens sortants (“out”) dans le cas d’un réseau orienté.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb33"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb33-1"><a href="#cb33-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Création d'une liste d'objets igraph (tous les ego-networks) </span></span>
<span id="cb33-2"><a href="#cb33-2" aria-hidden="true" tabindex="-1"></a>EgoNet_karate <span class="ot">&lt;-</span> <span class="fu">make_ego_graph</span>(karate)</span>
<span id="cb33-3"><a href="#cb33-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb33-4"><a href="#cb33-4" aria-hidden="true" tabindex="-1"></a><span class="co"># Paramétrage de l'ego network</span></span>
<span id="cb33-5"><a href="#cb33-5" aria-hidden="true" tabindex="-1"></a>EgoNet_karate <span class="ot">&lt;-</span> <span class="fu">make_ego_graph</span>(karate,</span>
<span id="cb33-6"><a href="#cb33-6" aria-hidden="true" tabindex="-1"></a>                                <span class="at">nodes =</span> <span class="fu">V</span>(karate),</span>
<span id="cb33-7"><a href="#cb33-7" aria-hidden="true" tabindex="-1"></a>                                <span class="at">order =</span> <span class="dv">1</span>,</span>
<span id="cb33-8"><a href="#cb33-8" aria-hidden="true" tabindex="-1"></a>                                <span class="at">mode =</span> <span class="fu">c</span>(<span class="st">"all"</span>))</span>
<span id="cb33-9"><a href="#cb33-9" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb33-10"><a href="#cb33-10" aria-hidden="true" tabindex="-1"></a><span class="co"># Sélectionner un ego-network dans la liste - V(karate)$name[1]</span></span>
<span id="cb33-11"><a href="#cb33-11" aria-hidden="true" tabindex="-1"></a>EgoNet_karate[[<span class="dv">1</span>]] <span class="co"># ici le premier </span></span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH d54363b UNW- 18 36 -- Zachary's karate club network
+ attr: name (g/c), Author (g/c), Citation (g/c), name (v/c), label
| (v/c), Faction (v/n), color (v/n), position (v/c), weight (e/n)
+ edges from d54363b (vertex names):
 [1] Mr Hi  --Actor 2  Mr Hi  --Actor 3  Mr Hi  --Actor 4  Mr Hi  --Actor 5 
 [5] Mr Hi  --Actor 6  Mr Hi  --Actor 7  Mr Hi  --Actor 8  Mr Hi  --Actor 9 
 [9] Mr Hi  --Actor 11 Mr Hi  --Actor 12 Mr Hi  --Actor 13 Mr Hi  --Actor 14
[13] Mr Hi  --Actor 18 Mr Hi  --Actor 20 Mr Hi  --Actor 22 Mr Hi  --Actor 32
[17] Actor 2--Actor 3  Actor 2--Actor 4  Actor 2--Actor 8  Actor 2--Actor 14
[21] Actor 2--Actor 18 Actor 2--Actor 20 Actor 2--Actor 22 Actor 3--Actor 4 
[25] Actor 3--Actor 8  Actor 3--Actor 9  Actor 3--Actor 14 Actor 4--Actor 8 
+ ... omitted several edges</code></pre>
</div>
<div class="sourceCode cell-code" id="cb35"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb35-1"><a href="#cb35-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Création d'un ego-network à partir d'un nom (crée une liste avec un ego-network)</span></span>
<span id="cb35-2"><a href="#cb35-2" aria-hidden="true" tabindex="-1"></a>EgoNet_JohnA <span class="ot">&lt;-</span> <span class="fu">make_ego_graph</span>(karate,</span>
<span id="cb35-3"><a href="#cb35-3" aria-hidden="true" tabindex="-1"></a>                               <span class="at">nodes =</span> <span class="fu">V</span>(karate)[name<span class="sc">==</span><span class="st">'John A'</span>], <span class="co"># on peut aussi faire label=="A"</span></span>
<span id="cb35-4"><a href="#cb35-4" aria-hidden="true" tabindex="-1"></a>                               <span class="at">order =</span> <span class="dv">1</span>,</span>
<span id="cb35-5"><a href="#cb35-5" aria-hidden="true" tabindex="-1"></a>                               <span class="at">mode =</span> <span class="fu">c</span>(<span class="st">"all"</span>))</span>
<span id="cb35-6"><a href="#cb35-6" aria-hidden="true" tabindex="-1"></a>EgoNet_JohnA[[<span class="dv">1</span>]]</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH 030da36 UNW- 18 32 -- Zachary's karate club network
+ attr: name (g/c), Author (g/c), Citation (g/c), name (v/c), label
| (v/c), Faction (v/n), color (v/n), position (v/c), weight (e/n)
+ edges from 030da36 (vertex names):
 [1] Actor 9 --Actor 31 Actor 9 --Actor 33 Actor 9 --John A   Actor 10--John A  
 [5] Actor 14--John A   Actor 15--Actor 33 Actor 15--John A   Actor 16--Actor 33
 [9] Actor 16--John A   Actor 19--Actor 33 Actor 19--John A   Actor 20--John A  
[13] Actor 21--Actor 33 Actor 21--John A   Actor 23--Actor 33 Actor 23--John A  
[17] Actor 24--Actor 28 Actor 24--Actor 30 Actor 24--Actor 33 Actor 24--John A  
[21] Actor 27--Actor 30 Actor 27--John A   Actor 28--John A   Actor 29--Actor 32
[25] Actor 29--John A   Actor 30--Actor 33 Actor 30--John A   Actor 31--Actor 33
+ ... omitted several edges</code></pre>
</div>
</div>
<div class="cell">
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-23-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
<p>Supprimer ego de son réseau personnel.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb37"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb37-1"><a href="#cb37-1" aria-hidden="true" tabindex="-1"></a>Karate_sans_Hi <span class="ot">&lt;-</span> <span class="fu">induced_subgraph</span>(EgoNet_karate[[<span class="dv">1</span>]], </span>
<span id="cb37-2"><a href="#cb37-2" aria-hidden="true" tabindex="-1"></a>                                   <span class="at">v =</span> <span class="fu">which</span>(<span class="fu">V</span>(EgoNet_karate[[<span class="dv">1</span>]])<span class="sc">$</span>name <span class="sc">!=</span> <span class="fu">c</span>(<span class="st">"Mr Hi"</span>)))</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<div class="cell">
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-25-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
<p><br>
</p>
<p>S’il est facile de créer les réseaux personnels à partir d’un réseau complet, <code>igraph</code> ne propose pas les mesures spécifiques développées pour l’analyse des réseaux personnels.</p>
</section>
<section id="boucles-et-liens-multiples" class="level2" data-number="1.8">
<h2 data-number="1.8" class="anchored" data-anchor-id="boucles-et-liens-multiples"><span class="header-section-number">1.8</span> Boucles et liens multiples</h2>
<p><code>igraph</code> peut prendre en charge des réseaux avec boucles (liens d’un sommet vers lui-même) et liens multiples ; certaines mesures fonctionnent sans problème avec ce type de réseau. La fonction <code>simplify()</code> permet de transformer ces réseaux en réseaux simples. La fonction <code>simplify_and_colorize()</code> permet de garder en mémoire l’existence de ces boucles et liens multiples.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb38"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb38-1"><a href="#cb38-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Manipulation d'un réseau avec boucle et liens multiples</span></span>
<span id="cb38-2"><a href="#cb38-2" aria-hidden="true" tabindex="-1"></a>gbm <span class="ot">&lt;-</span> d1 <span class="ot">&lt;-</span> <span class="fu">rbind</span>(<span class="fu">c</span>(<span class="st">"A"</span>,<span class="st">"A"</span>),</span>
<span id="cb38-3"><a href="#cb38-3" aria-hidden="true" tabindex="-1"></a>                   <span class="fu">c</span>(<span class="st">"A"</span>,<span class="st">"B"</span>),</span>
<span id="cb38-4"><a href="#cb38-4" aria-hidden="true" tabindex="-1"></a>                   <span class="fu">c</span>(<span class="st">"B"</span>,<span class="st">"C"</span>), </span>
<span id="cb38-5"><a href="#cb38-5" aria-hidden="true" tabindex="-1"></a>                   <span class="fu">c</span>(<span class="st">"B"</span>,<span class="st">"C"</span>), </span>
<span id="cb38-6"><a href="#cb38-6" aria-hidden="true" tabindex="-1"></a>                   <span class="fu">c</span>(<span class="st">"B"</span>,<span class="st">"C"</span>), </span>
<span id="cb38-7"><a href="#cb38-7" aria-hidden="true" tabindex="-1"></a>                   <span class="fu">c</span>(<span class="st">"C"</span>,<span class="st">"D"</span>), </span>
<span id="cb38-8"><a href="#cb38-8" aria-hidden="true" tabindex="-1"></a>                   <span class="fu">c</span>(<span class="st">"C"</span>,<span class="st">"D"</span>))</span>
<span id="cb38-9"><a href="#cb38-9" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb38-10"><a href="#cb38-10" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb38-11"><a href="#cb38-11" aria-hidden="true" tabindex="-1"></a>g1 <span class="ot">&lt;-</span> <span class="fu">graph.data.frame</span>(d1, <span class="at">directed =</span> <span class="cn">FALSE</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stderr">
<pre><code>Warning: `graph.data.frame()` was deprecated in igraph 2.0.0.
ℹ Please use `graph_from_data_frame()` instead.</code></pre>
</div>
<div class="sourceCode cell-code" id="cb40"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb40-1"><a href="#cb40-1" aria-hidden="true" tabindex="-1"></a>g1</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH 1d083fd UN-- 4 7 -- 
+ attr: name (v/c)
+ edges from 1d083fd (vertex names):
[1] A--A A--B B--C B--C B--C C--D C--D</code></pre>
</div>
<div class="sourceCode cell-code" id="cb42"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb42-1"><a href="#cb42-1" aria-hidden="true" tabindex="-1"></a><span class="fu">is.loop</span>(g1)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stderr">
<pre><code>Warning: `is.loop()` was deprecated in igraph 2.0.0.
ℹ Please use `which_loop()` instead.</code></pre>
</div>
<div class="cell-output cell-output-stdout">
<pre><code>[1]  TRUE FALSE FALSE FALSE FALSE FALSE FALSE</code></pre>
</div>
<div class="sourceCode cell-code" id="cb45"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb45-1"><a href="#cb45-1" aria-hidden="true" tabindex="-1"></a><span class="fu">is.multiple</span>(g1)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stderr">
<pre><code>Warning: `is.multiple()` was deprecated in igraph 2.0.0.
ℹ Please use `which_multiple()` instead.</code></pre>
</div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] FALSE FALSE FALSE  TRUE  TRUE FALSE  TRUE</code></pre>
</div>
<div class="sourceCode cell-code" id="cb48"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb48-1"><a href="#cb48-1" aria-hidden="true" tabindex="-1"></a><span class="fu">plot</span>(g1)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-26-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
<div class="sourceCode cell-code" id="cb49"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb49-1"><a href="#cb49-1" aria-hidden="true" tabindex="-1"></a><span class="fu">degree</span>(g1)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>A B C D 
3 4 5 2 </code></pre>
</div>
</div>
<p>La fonction <code>degree()</code> donne un résultat satisfaisant. Le sommet <em>A</em> a un degré de 3 : un lien avec <em>B</em> et une boucle. Par convention, une boucle est considérée comme un lien entrant plus un lien sortant et le degré d’un sommet avec boucle est donc toujours supérieur ou égal à 2.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb51"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb51-1"><a href="#cb51-1" aria-hidden="true" tabindex="-1"></a><span class="fu">graph.density</span>(g1)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stderr">
<pre><code>Warning: `graph.density()` was deprecated in igraph 2.0.0.
ℹ Please use `edge_density()` instead.</code></pre>
</div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] 1.166667</code></pre>
</div>
</div>
<p>Par contre, la densité donne un résultat logique mais peu satisfaisant. Il considère qu’il y a 7 liens présents et 6 liens possibles (4*3/2) d’où une densité supérieure à 1. Or, le nombre de liens possibles est de 10 (si on considère que des boucles peuvent être partout présentes) voire de 22 (3 liens possibles entre chaque paire de sommets donc 3 fois 6, plus 4 boucles).</p>
<p>L’approche standard en analyse de réseau avec ce type d’objet est de commencer par supprimer boucles et liens multiples.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb54"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb54-1"><a href="#cb54-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Par défaut, simplify supprimer boucles et liens multiples</span></span>
<span id="cb54-2"><a href="#cb54-2" aria-hidden="true" tabindex="-1"></a>g1_2 <span class="ot">&lt;-</span> <span class="fu">simplify</span>(g1)</span>
<span id="cb54-3"><a href="#cb54-3" aria-hidden="true" tabindex="-1"></a><span class="fu">plot</span>(g1_2)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-28-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
<div class="sourceCode cell-code" id="cb55"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb55-1"><a href="#cb55-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Si je veux garder les liens multiples</span></span>
<span id="cb55-2"><a href="#cb55-2" aria-hidden="true" tabindex="-1"></a>g1_3 <span class="ot">&lt;-</span> <span class="fu">simplify</span>(g1, <span class="at">remove.multiple =</span> <span class="cn">FALSE</span>)</span>
<span id="cb55-3"><a href="#cb55-3" aria-hidden="true" tabindex="-1"></a><span class="fu">plot</span>(g1_3)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-28-2.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
<div class="sourceCode cell-code" id="cb56"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb56-1"><a href="#cb56-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Si je veux garder une trace des boucles et des liens multiples</span></span>
<span id="cb56-2"><a href="#cb56-2" aria-hidden="true" tabindex="-1"></a>g1_4 <span class="ot">&lt;-</span> <span class="fu">simplify_and_colorize</span>(g1)</span>
<span id="cb56-3"><a href="#cb56-3" aria-hidden="true" tabindex="-1"></a>g1_4</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH e10d411 U--- 4 3 -- 
+ attr: color (v/n), color (e/n)
+ edges from e10d411:
[1] 1--2 2--3 3--4</code></pre>
</div>
<div class="sourceCode cell-code" id="cb58"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb58-1"><a href="#cb58-1" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(g1_4)<span class="sc">$</span>color <span class="co"># il y avait une boucle au premier sommet</span></span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] 1 0 0 0</code></pre>
</div>
<div class="sourceCode cell-code" id="cb60"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb60-1"><a href="#cb60-1" aria-hidden="true" tabindex="-1"></a><span class="fu">E</span>(g1_4)<span class="sc">$</span>color <span class="co"># il y avait 1 lien, 3 liens, 2 liens</span></span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] 1 3 2</code></pre>
</div>
</div>
</section>
<section id="réseau-bimodal-ou-biparti" class="level2" data-number="1.9">
<h2 data-number="1.9" class="anchored" data-anchor-id="réseau-bimodal-ou-biparti"><span class="header-section-number">1.9</span> Réseau bimodal (ou biparti)</h2>
<p>Pour qu’un réseau soit considéré comme biparti, il faut que la table des sommets contienne un attribut booléen nommé <code>type</code> pour différencier les deux catégories de sommets. Cette condition est nécessaire et suffisante.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb62"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb62-1"><a href="#cb62-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Fonction pour savoir si le graphe est biparti</span></span>
<span id="cb62-2"><a href="#cb62-2" aria-hidden="true" tabindex="-1"></a><span class="fu">is.bipartite</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] FALSE</code></pre>
</div>
<div class="sourceCode cell-code" id="cb64"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb64-1"><a href="#cb64-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Création de l'attribut "type" </span></span>
<span id="cb64-2"><a href="#cb64-2" aria-hidden="true" tabindex="-1"></a><span class="co"># Valeur booléenne pour dissocier les deux groupes</span></span>
<span id="cb64-3"><a href="#cb64-3" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(karate)<span class="sc">$</span>type <span class="ot">&lt;-</span> <span class="fu">ifelse</span>(<span class="fu">V</span>(karate)<span class="sc">$</span>color <span class="sc">==</span> <span class="dv">1</span>, <span class="cn">TRUE</span>, <span class="cn">FALSE</span>)</span>
<span id="cb64-4"><a href="#cb64-4" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb64-5"><a href="#cb64-5" aria-hidden="true" tabindex="-1"></a><span class="co"># La présence de l'attribut "type" rend l'objet igraph biparti</span></span>
<span id="cb64-6"><a href="#cb64-6" aria-hidden="true" tabindex="-1"></a><span class="fu">is.bipartite</span>(karate)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] TRUE</code></pre>
</div>
</div>
<p>Comme il y a un attribut <code>type</code> booléen sur les sommets, <code>igraph</code> considère que le réseau est bimodal alors que la liste des liens montre qu’il ne l’est pas. Il ne sera pas possible, et c’est normal, de transformer ce faux réseau bimodal.</p>
<p>Le script ci-dessous crée un mini réseau bimodal. <code>igraph</code> permet peu d’analyse. Si le degré donne un résultat correct, le degré normalisé est faux, tout comme la densité.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb66"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb66-1"><a href="#cb66-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Création d'un réseau minimal</span></span>
<span id="cb66-2"><a href="#cb66-2" aria-hidden="true" tabindex="-1"></a>som <span class="ot">&lt;-</span> <span class="fu">c</span>(<span class="st">"a1"</span>,<span class="st">"a2"</span>,<span class="st">"a3"</span>,<span class="st">"a4"</span>,<span class="st">"A1"</span>,<span class="st">"A2"</span>,<span class="st">"A3"</span>)</span>
<span id="cb66-3"><a href="#cb66-3" aria-hidden="true" tabindex="-1"></a>somtype <span class="ot">&lt;-</span> <span class="fu">c</span>(<span class="dv">0</span>,<span class="dv">1</span>,<span class="dv">0</span>,<span class="dv">1</span>,<span class="dv">1</span>,<span class="dv">0</span>,<span class="dv">0</span>)</span>
<span id="cb66-4"><a href="#cb66-4" aria-hidden="true" tabindex="-1"></a>gb <span class="ot">&lt;-</span> <span class="fu">make_graph</span>(<span class="fu">c</span>(<span class="st">"a1"</span>,<span class="st">"A1"</span>,<span class="st">"a2"</span>,<span class="st">"A1"</span>,</span>
<span id="cb66-5"><a href="#cb66-5" aria-hidden="true" tabindex="-1"></a>                     <span class="st">"a2"</span>,<span class="st">"A2"</span>,<span class="st">"a2"</span>,<span class="st">"A3"</span>,</span>
<span id="cb66-6"><a href="#cb66-6" aria-hidden="true" tabindex="-1"></a>                     <span class="st">"a3"</span>,<span class="st">"A2"</span>,<span class="st">"a4"</span>,<span class="st">"A3"</span>,</span>
<span id="cb66-7"><a href="#cb66-7" aria-hidden="true" tabindex="-1"></a>                     <span class="st">"a4"</span>, <span class="st">"A2"</span>), <span class="at">directed =</span> <span class="cn">FALSE</span>)</span>
<span id="cb66-8"><a href="#cb66-8" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb66-9"><a href="#cb66-9" aria-hidden="true" tabindex="-1"></a>gb</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH 749f45a UN-- 7 7 -- 
+ attr: name (v/c)
+ edges from 749f45a (vertex names):
[1] a1--A1 A1--a2 a2--A2 a2--A3 A2--a3 A3--a4 A2--a4</code></pre>
</div>
</div>
<p>Il n’y a pas de variable attribut booléen ‘type’, le réseau est donc considéré comme un réseau unimodal.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb68"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb68-1"><a href="#cb68-1" aria-hidden="true" tabindex="-1"></a><span class="fu">V</span>(gb)<span class="sc">$</span>type <span class="ot">&lt;-</span> somtype</span>
<span id="cb68-2"><a href="#cb68-2" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb68-3"><a href="#cb68-3" aria-hidden="true" tabindex="-1"></a>gb</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>IGRAPH 749f45a UN-B 7 7 -- 
+ attr: name (v/c), type (v/n)
+ edges from 749f45a (vertex names):
[1] a1--A1 A1--a2 a2--A2 a2--A3 A2--a3 A3--a4 A2--a4</code></pre>
</div>
</div>
<p><em>UN-<strong>B</strong></em> signale que le réseau est dorénavant considéré comme <strong>biparti</strong>.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb70"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb70-1"><a href="#cb70-1" aria-hidden="true" tabindex="-1"></a><span class="fu">plot</span>(gb, <span class="at">layout =</span> <span class="fu">layout_as_bipartite</span>(gb))</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-32-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
<div class="sourceCode cell-code" id="cb71"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb71-1"><a href="#cb71-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Degré : résultat correct</span></span>
<span id="cb71-2"><a href="#cb71-2" aria-hidden="true" tabindex="-1"></a><span class="fu">degree</span>(gb)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>a1 A1 a2 A2 A3 a3 a4 
 1  2  3  3  2  1  2 </code></pre>
</div>
<div class="sourceCode cell-code" id="cb73"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb73-1"><a href="#cb73-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Degré nortmalisé : résultat faux</span></span>
<span id="cb73-2"><a href="#cb73-2" aria-hidden="true" tabindex="-1"></a><span class="fu">degree</span>(gb, <span class="at">normalized =</span> <span class="cn">TRUE</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>       a1        A1        a2        A2        A3        a3        a4 
0.1666667 0.3333333 0.5000000 0.5000000 0.3333333 0.1666667 0.3333333 </code></pre>
</div>
<div class="sourceCode cell-code" id="cb75"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb75-1"><a href="#cb75-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Densité : résultat faux</span></span>
<span id="cb75-2"><a href="#cb75-2" aria-hidden="true" tabindex="-1"></a><span class="fu">graph.density</span>(gb)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] 0.3333333</code></pre>
</div>
</div>
<p>Dans un réseau bimodal <span class="math inline">\(G = \{V_1, V_2, E\}\)</span>, le degré maximum d’un sommet de l’ensemble <span class="math inline">\(V_1\)</span> est égal au nombre de sommets de l’ensemble <span class="math inline">\(V_2\)</span>. Pour normaliser, on divise par le nombre du sommets de l’autre ensemble. Ici par exemple, <em>a1</em> a un degré de 1, le maximum est 3, son degré normalisé est donc de 1/3.</p>
<p>En ce qui concerne la densité, le nombre maximum de liens possibles est égal à <span class="math inline">\(V_1 \times V_2\)</span> soit 12 dans cet exemple. Il y a 7 liens, la densité est donc de 0.58.</p>
<p>L’une des seules options disponibles est la possibilité de le projeter pour créer deux réseaux unimodaux valués.</p>
<p>Si je considère que les lettres majuscules sont des autrices publiant dans des revues (lettres minuscules), un lien entre deux revues (réseau du milieu) indique combien ces revues partagent d’autrices en commun. Un lien entre deux autrices dans le réseau valué de droite indiquent dans combien de revues communes elles ont publié.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb77"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb77-1"><a href="#cb77-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Projections du réseau bimodal</span></span>
<span id="cb77-2"><a href="#cb77-2" aria-hidden="true" tabindex="-1"></a>pro <span class="ot">&lt;-</span> <span class="fu">bipartite.projection</span>(gb)</span>
<span id="cb77-3"><a href="#cb77-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb77-4"><a href="#cb77-4" aria-hidden="true" tabindex="-1"></a><span class="co"># Intensité des liens dans la première projection</span></span>
<span id="cb77-5"><a href="#cb77-5" aria-hidden="true" tabindex="-1"></a><span class="fu">E</span>(pro[[<span class="dv">1</span>]])<span class="sc">$</span>weight</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] 1 1 2 1</code></pre>
</div>
<div class="sourceCode cell-code" id="cb79"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb79-1"><a href="#cb79-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Intensité des liens dans la deuxième projection</span></span>
<span id="cb79-2"><a href="#cb79-2" aria-hidden="true" tabindex="-1"></a><span class="fu">E</span>(pro[[<span class="dv">2</span>]])<span class="sc">$</span>weight</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
<div class="cell-output cell-output-stdout">
<pre><code>[1] 1 1 2</code></pre>
</div>
</div>
<p>Visualisation du réseau biparti et des deux projections qui en découlent :</p>
<div class="cell">
<div class="cell-output-display">
<div>
<figure class="figure">
<p><img src="igraph_files/figure-html/unnamed-chunk-35-1.png" class="img-fluid figure-img" width="672"></p>
</figure>
</div>
</div>
</div>
</section>
<section id="exporter-un-objet-igraph" class="level2" data-number="1.10">
<h2 data-number="1.10" class="anchored" data-anchor-id="exporter-un-objet-igraph"><span class="header-section-number">1.10</span> Exporter un objet <code>igraph</code></h2>
<p>Extraire les tableaux des sommets et des arêtes avec leur attributs.</p>
<div class="cell">
<div class="sourceCode cell-code" id="cb81"><pre class="sourceCode r code-with-copy"><code class="sourceCode r"><span id="cb81-1"><a href="#cb81-1" aria-hidden="true" tabindex="-1"></a><span class="co"># Extraction des liens et de leurs attributs</span></span>
<span id="cb81-2"><a href="#cb81-2" aria-hidden="true" tabindex="-1"></a>tableau_aretes <span class="ot">&lt;-</span> <span class="fu">as_data_frame</span>(karate, <span class="at">what=</span><span class="st">"edges"</span>)</span>
<span id="cb81-3"><a href="#cb81-3" aria-hidden="true" tabindex="-1"></a></span>
<span id="cb81-4"><a href="#cb81-4" aria-hidden="true" tabindex="-1"></a><span class="co"># Extraction des sommets et de leurs attributs</span></span>
<span id="cb81-5"><a href="#cb81-5" aria-hidden="true" tabindex="-1"></a>tableau_sommets <span class="ot">&lt;-</span> <span class="fu">as_data_frame</span>(karate, <span class="at">what=</span><span class="st">"vertices"</span>)</span></code><button title="Copier vers le presse-papier" class="code-copy-button"><i class="bi"></i></button></pre></div>
</div>
<p><br>
</p>


</section>

</main> <!-- /main -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const onCopySuccess = function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copié");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copié");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  }
  const getTextToCopy = function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button:not([data-in-quarto-modal])', {
    text: getTextToCopy
  });
  clipboard.on('success', onCopySuccess);
  if (window.document.getElementById('quarto-embedded-source-code-modal')) {
    // For code content inside modals, clipBoardJS needs to be initialized with a container option
    // TODO: Check when it could be a function (https://github.com/zenorocha/clipboard.js/issues/860)
    const clipboardModal = new window.ClipboardJS('.code-copy-button[data-in-quarto-modal]', {
      text: getTextToCopy,
      container: window.document.getElementById('quarto-embedded-source-code-modal')
    });
    clipboardModal.on('success', onCopySuccess);
  }
    var localhostRegex = new RegExp(/^(?:http|https):\/\/localhost\:?[0-9]*\//);
    var mailtoRegex = new RegExp(/^mailto:/);
      var filterRegex = new RegExp('/' + window.location.host + '/');
    var isInternal = (href) => {
        return filterRegex.test(href) || localhostRegex.test(href) || mailtoRegex.test(href);
    }
    // Inspect non-navigation links and adorn them if external
 	var links = window.document.querySelectorAll('a[href]:not(.nav-link):not(.navbar-brand):not(.toc-action):not(.sidebar-link):not(.sidebar-item-toggle):not(.pagination-link):not(.no-external):not([aria-hidden]):not(.dropdown-item):not(.quarto-navigation-tool):not(.about-link)');
    for (var i=0; i<links.length; i++) {
      const link = links[i];
      if (!isInternal(link.href)) {
        // undo the damage that might have been done by quarto-nav.js in the case of
        // links that we want to consider external
        if (link.dataset.originalHref !== undefined) {
          link.href = link.dataset.originalHref;
        }
      }
    }
  function tippyHover(el, contentFn, onTriggerFn, onUntriggerFn) {
    const config = {
      allowHTML: true,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start',
    };
    if (contentFn) {
      config.content = contentFn;
    }
    if (onTriggerFn) {
      config.onTrigger = onTriggerFn;
    }
    if (onUntriggerFn) {
      config.onUntrigger = onUntriggerFn;
    }
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      if (note) {
        return note.innerHTML;
      } else {
        return "";
      }
    });
  }
  const xrefs = window.document.querySelectorAll('a.quarto-xref');
  const processXRef = (id, note) => {
    // Strip column container classes
    const stripColumnClz = (el) => {
      el.classList.remove("page-full", "page-columns");
      if (el.children) {
        for (const child of el.children) {
          stripColumnClz(child);
        }
      }
    }
    stripColumnClz(note)
    if (id === null || id.startsWith('sec-')) {
      // Special case sections, only their first couple elements
      const container = document.createElement("div");
      if (note.children && note.children.length > 2) {
        container.appendChild(note.children[0].cloneNode(true));
        for (let i = 1; i < note.children.length; i++) {
          const child = note.children[i];
          if (child.tagName === "P" && child.innerText === "") {
            continue;
          } else {
            container.appendChild(child.cloneNode(true));
            break;
          }
        }
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(container);
        }
        return container.innerHTML
      } else {
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(note);
        }
        return note.innerHTML;
      }
    } else {
      // Remove any anchor links if they are present
      const anchorLink = note.querySelector('a.anchorjs-link');
      if (anchorLink) {
        anchorLink.remove();
      }
      if (window.Quarto?.typesetMath) {
        window.Quarto.typesetMath(note);
      }
      // TODO in 1.5, we should make sure this works without a callout special case
      if (note.classList.contains("callout")) {
        return note.outerHTML;
      } else {
        return note.innerHTML;
      }
    }
  }
  for (var i=0; i<xrefs.length; i++) {
    const xref = xrefs[i];
    tippyHover(xref, undefined, function(instance) {
      instance.disable();
      let url = xref.getAttribute('href');
      let hash = undefined; 
      if (url.startsWith('#')) {
        hash = url;
      } else {
        try { hash = new URL(url).hash; } catch {}
      }
      if (hash) {
        const id = hash.replace(/^#\/?/, "");
        const note = window.document.getElementById(id);
        if (note !== null) {
          try {
            const html = processXRef(id, note.cloneNode(true));
            instance.setContent(html);
          } finally {
            instance.enable();
            instance.show();
          }
        } else {
          // See if we can fetch this
          fetch(url.split('#')[0])
          .then(res => res.text())
          .then(html => {
            const parser = new DOMParser();
            const htmlDoc = parser.parseFromString(html, "text/html");
            const note = htmlDoc.getElementById(id);
            if (note !== null) {
              const html = processXRef(id, note);
              instance.setContent(html);
            } 
          }).finally(() => {
            instance.enable();
            instance.show();
          });
        }
      } else {
        // See if we can fetch a full url (with no hash to target)
        // This is a special case and we should probably do some content thinning / targeting
        fetch(url)
        .then(res => res.text())
        .then(html => {
          const parser = new DOMParser();
          const htmlDoc = parser.parseFromString(html, "text/html");
          const note = htmlDoc.querySelector('main.content');
          if (note !== null) {
            // This should only happen for chapter cross references
            // (since there is no id in the URL)
            // remove the first header
            if (note.children.length > 0 && note.children[0].tagName === "HEADER") {
              note.children[0].remove();
            }
            const html = processXRef(null, note);
            instance.setContent(html);
          } 
        }).finally(() => {
          instance.enable();
          instance.show();
        });
      }
    }, function(instance) {
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            div.style.left = 0;
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
        // Handle positioning of the toggle
    window.addEventListener(
      "resize",
      throttle(() => {
        elRect = undefined;
        if (selectedAnnoteEl) {
          selectCodeLines(selectedAnnoteEl);
        }
      }, 10)
    );
    function throttle(fn, ms) {
    let throttle = false;
    let timer;
      return (...args) => {
        if(!throttle) { // first call gets through
            fn.apply(this, args);
            throttle = true;
        } else { // all the others get throttled
            if(timer) clearTimeout(timer); // cancel #2
            timer = setTimeout(() => {
              fn.apply(this, args);
              timer = throttle = false;
            }, ms);
        }
      };
    }
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
<nav class="page-navigation">
  <div class="nav-page nav-page-previous">
      <a href="./index.html" class="pagination-link" aria-label="Le package `igraph`">
        <i class="bi bi-arrow-left-short"></i> <span class="nav-page-text">Le package <code>igraph</code></span>
      </a>          
  </div>
  <div class="nav-page nav-page-next">
      <a href="./indicateurs.html" class="pagination-link" aria-label="Indicateurs globaux">
        <span class="nav-page-text"><span class="chapter-number">2</span>&nbsp; <span class="chapter-title">Indicateurs globaux</span></span> <i class="bi bi-arrow-right-short"></i>
      </a>
  </div>
</nav>
</div> <!-- /content -->
<footer class="footer">
  <div class="nav-footer">
    <div class="nav-footer-left">
<div class="quarto-figure quarto-figure-center">
<figure class="figure">
<p><a href="https://creativecommons.org/licenses/by-nc-sa/4.0/"><img src="img/by-nc-sa.png" class="img-fluid figure-img" alt="CreativeCommonsLicense"></a></p>
<figcaption>CreativeCommonsLicense</figcaption>
</figure>
</div>
</div>   
    <div class="nav-footer-center">
      &nbsp;
    </div>
    <div class="nav-footer-right">
      &nbsp;
    </div>
  </div>
</footer>




</body></html>